{*******************************************************}
{                                                       }
{       Run-time Library for Borland Delphi 5           }
{       Converting string to expression of X            }
{                                                       }
{       Copyright (c)  2001-2002 by Veresov Dmitry      }
{                                                       }
{     *****                                             }
{     **   **                                           }
{     **    **       ************                       }
{     **    **     **     **     **                     }
{     **    **     **     **     **                     }
{     **   **      **     **     **                     }
{     *****        ***    ***    ****                   }
{                                                       }
{*******************************************************}

// +, -, /, *, ^, (), x
// sin(x), cos(x), tan(x), cotan(x), arcsin(x), arccos(x), arctan(x), arccotan(x)
// sqrt(x), abs(x), ln(x), lg(x), logN(x;base), exp(x), round(x)
// If(Logical_test; Value_If_True; Value_If_False)

unit FunctionX;

interface

uses
  Math, SysUtils;

  type
    Tfunc = set of (Fplus,Fminus,Fmultiply,Fdivide,Fnone,Fpower);
    TZnak = set of (Zravno,ZBolhe,Zmenhe,ZBolheRavno,ZMenheRavno,ZneRavno);
    Tresult = record
    Nofunction : integer;
    Typefunction : Tfunc;
  end;
  type
    TFindFuncion = record
    Name : String;
    FirstChar : integer;
    Width : integer;
    firstcharname : integer;
  end;

  const
   znaki : set of char = ['+','-','*','/','^'];
   logicznaki : set of char = ['>','<','='];
   BukviF : set of char = ['A'..'Z','a'..'z'];
   zifri : set of char = ['0'..'9'];

Function StringtofunctionX(fstr : string; X,Y,Z :real) : real; forward;
function findnextf(strfunction : string) : Tresult;
function findnextl(nofunction : integer; s : string) : integer;
function findnextr(nofunction : integer; s : string) : integer;
function findnextx(str : string):integer;
function loadfloar(str : string): real;
Function replacefunctionstoresult(str : string) : string;
function findnextpi(str : string): integer;
Function findexpression(str : String) : boolean;
Function FindErrors(Funct : String; Displacement: integer; var errorchar : integer) : String; forward;
Function FindFunctionname(s:string; i : integer) : TFindFuncion;
Function FindNextChar(s : string; i : integer):char;
Function ValueExists(S : String) : Boolean;
Function DeleteProbeli(S : String) : String;
Function FindNextCharNo(s : string; i : integer; var no : integer): char;
Function IsIfOrLognEnd(s : String; beginchar : Integer; ifLog : boolean) : integer;
Function FindpreviosChar(s : string; i : integer; no : integer): char;
Function findnextcharwithoutznaki(s : string; i : integer):char;
Function testvalueondb(s : string; i : integer):boolean;

implementation

function Upcaseall(s : string):string;
var i : integer;
begin
result:=s;
for i:=1 to length(s) do
result[i]:=Upcase(result[i]);
end;

function loadfloar(str: string): real;
var s:string;
 minusi,i : integer;
begin
minusi:=0;
If str='' then begin result:=0; exit; end;
s:=str;
If s[1]='(' then
begin
For i:=1 to length(s) div 2 do
If (s[i]='-') then inc(minusi);
For i:=length(s) div 2 downto 1 do
If (s[i]='-') then delete(s,i,1);
end;
result:=0;
If s='' then exit;
Repeat
If s[1]='(' then
begin
delete(s,length(s),1);
delete(s,1,1);
If s='' then exit;
end;
until s[1]<>'(';
If not odd(minusi) then result:=strtofloat(s) else result:=-strtofloat(s);
end;

function findnextx(str: string): integer;
var i:integer;
begin
result:=-1;
for i:=1 to length(str) do
If (str[i]='X') and (str[i-1]<>'E') then
begin
result:=i;
break;
end;
end;

function findnexty(str: string): integer;
var i:integer;
begin
result:=-1;
for i:=1 to length(str) do
If (str[i]='Y') then
begin
result:=i;
break;
end;
end;

function findnextz(str: string): integer;
var i:integer;
begin
result:=-1;
for i:=1 to length(str) do
If (str[i]='Z') then
begin
result:=i;
break;
end;
end;

function findnextpi(str: string): integer;
var i:integer;
begin
result:=-1;
for i:=1 to length(str)-1 do
If (str[i]='P') and (str[i+1]='I') then
begin
result:=i;
break;
end;
end;

function findnextf(strfunction:string):Tresult;
var i:integer;
find : boolean;
begin
find:=false;
result.nofunction:=-1;
result.typefunction:=[fnone];
If not find then
for i:=1 to length(strfunction) do
If strfunction[i]='^' then begin find:=true; result.nofunction:=i; result.typefunction:=[Fpower]; break; end;
If not find then
for i:=1 to length(strfunction) do
If strfunction[i]='*' then begin find:=true; result.nofunction:=i; result.typefunction:=[Fmultiply]; break; end;
If not find then
for i:=1 to length(strfunction) do
If strfunction[i]='/' then begin find:=true; result.nofunction:=i; result.typefunction:=[Fdivide]; break; end;
If not find then
for i:=1 to length(strfunction) do
If strfunction[i]='-' then If (i<>1) and (strfunction[i-1]<>'(') and (strfunction[i-1]<>'E') then begin find:=true; result.nofunction:=i; result.typefunction:=[Fminus]; break; end;
If not find then
for i:=1 to length(strfunction) do
If strfunction[i]='+' then begin result.nofunction:=i; result.typefunction:=[Fplus]; break; end;
end;

function findnextr(nofunction:integer;s:string):integer;
var i:integer;
begin
result:=length(s)+1;
for i:=nofunction+1 to length(s) do
begin
If (s[i]='+') or (s[i]='*') or (s[i]='/') or (s[i]='^') then begin result:=i; break; end;
If (s[i]='-') and (s[i-1]<>'(') and (s[i-1]<>'E') then begin result:=i; break; end;
end;
end;

function findnextl(nofunction:integer;s:string):integer;
var i:integer;
begin
result:=0;
for i:=nofunction-1 downto 1 do
begin
If (s[i]='+') or (s[i]='*') or (s[i]='/') or (s[i]='^') then  begin result:=i; break; end;
If (s[i]='-') and (s[i-1]<>'(') and (s[i-1]<>'E') then begin result:=i; break; end;
end;
end;

Function replacefunctionstoresult(str:string):string;
var i,j,ns,sc,nv1,z,y,endif:integer;
s,s1,sv1,sv2,ysl1,ysl2:string;
znak: TZnak;
r,temp,temp_,temp__,sr1,sr2:real;
none:boolean;
noneNo:integer;
begin
noneno:=1;
s:=str;
repeat
none:=true;
for i:=noneNo to length(s) do
begin
ns:=0;
If (s[i]='A') then if (s[i+1]='B') and (s[i+2]='S') and (s[i+3]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+4 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+4,ns-i-4);
         r:=abs(loadfloar(s1));
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;
         
If (s[i]='R') then if (s[i+1]='A') and (s[i+2]='D') and (s[i+3]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+4 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+4,ns-i-4);
         r:=pi*2*(loadfloar(s1))/360;
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='S') then if (s[i+1]='Q') and (s[i+2]='R') and (s[i+3]='T') and (s[i+4]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+5 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+5,ns-i-5);
         temp:=loadfloar(s1);
         If temp>=0 then
         r:=sqrt(temp) else raise Ematherror.Create('Invalid Floating Operator. Exception On SQRT needs >= 0');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='L') then if (s[i+1]='O') and (s[i+2]='G') and (s[i+3]='N') and (s[i+4]='(') then
         begin
         sc:=0;
         noneno:=i+1;
         nv1:=0;
         none:=false;
         For j:=i+5 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then sc:=sc-1;
         If (s[j]=';') and (sc=0) then
         begin
         nv1:=j;
         break;
         end;
         end;
         sc:=1;
         sv1:=copy(s,i+5,nv1-i-5);
         sv1:=floattostr(stringtofunctionx(sv1,0,0,0));
         for j:=nv1 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,nv1+1,ns-nv1-1);
         s1:=Floattostr(stringtofunctionx(s1,0,0,0));
         temp:=loadfloar(s1);
         temp_:=loadfloar(sv1);
         r:=0;
         If (temp>0) and (temp_>0) and (temp_<>1) then
         r:=logn(temp,temp_) else begin
         If temp<0 then raise Ematherror.Create('Invalid Floating Operator. Base on LOGN needs >0');
         If temp_<0 then raise Ematherror.Create('Invalid Floating Operator. Value on LOGN needs >0');
         If temp_=0 then raise Ematherror.Create('Invalid Floating Operator. Value on LOGN needs <>0');
         end;
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='C') then if (s[i+1]='O') and (s[i+2]='S') and (s[i+3]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+4 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+4,ns-i-4);
         r:=cos(loadfloar(s1));
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='R') then if (s[i+1]='O') and (s[i+2]='U') and (s[i+3]='N') and (s[i+4]='D') and (s[i+5]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+6 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+6,ns-i-6);
         r:=floor(loadfloar(s1));
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='S') then if (s[i+1]='I') and (s[i+2]='N') and (s[i+3]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+4 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+4,ns-i-4);
         r:=sin(loadfloar(s1));
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i-1]<>'O') and (s[i]='T') and (s[i+1]='A') and (s[i+2]='N') and (s[i+3]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+4 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+4,ns-i-4);
         temp:=loadfloar(s1);
         If cos(temp)<>0 then
         r:=tan(temp) else raise Ematherror.Create('Invalid Floating Operator. TAN needs value <> pi/2 +p*n, n <- Z');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='C') then if (s[i+1]='O') and (s[i+2]='T') and (s[i+3]='A') and (s[i+4]='N') and (s[i+5]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+6 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+6,ns-i-6);
         temp:=loadfloar(s1);
         If sin(temp)<>0 then
         r:=cotan(temp) else raise Ematherror.Create('Invalid Floating Operator. COTAN needs value <> p*n, n <- Z');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='A') then if (s[i+1]='R') and (s[i+2]='C') and (s[i+3]='S') and (s[i+4]='I') and (s[i+5]='N') and (s[i+6]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+7 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+7,ns-i-7);
         temp:=loadfloar(s1);
         If abs(temp)<=1 then
         r:=arcsin(temp) else raise Ematherror.Create('Invalid Floating Operator. ARCSIN needs value <- [-1;1]');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='A') then if (s[i+1]='R') and (s[i+2]='C') and (s[i+3]='C') and (s[i+4]='O') and (s[i+5]='S') and (s[i+6]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+7 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+7,ns-i-7);
         temp:=loadfloar(s1);
         If abs(temp)<=1 then
         r:=arccos(temp) else raise Ematherror.Create('Invalid Floating Operator. ARCCOS needs value <- [-1;1]');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='A') then if (s[i+1]='R') and (s[i+2]='C') and (s[i+3]='T') and (s[i+4]='A') and (s[i+5]='N') and (s[i+6]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+7 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+7,ns-i-7);
         r:=arctan(loadfloar(s1));
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='A') then if (s[i+1]='R') and (s[i+2]='C') and (s[i+3]='C') and (s[i+4]='O') and (s[i+5]='T') and (s[i+6]='A') and (s[i+7]='N') and (s[i+8]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+9 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+9,ns-i-9);
         r:=-arctan(loadfloar(s1))+pi/2;
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='E') then if (s[i+1]='X') and (s[i+2]='P') and (s[i+3]='(') then
         begin
         sc:=1;
         noneno:=i+1;
         none:=false;
         for j:=i+4 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+4,ns-i-4);
         r:=exp(loadfloar(s1));
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='L') then if (s[i+1]='N') and (s[i+2]='(') then
         begin
         sc:=1;
         none:=false;
         noneno:=i+1;
         for j:=i+3 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+3,ns-i-3);
         temp:=loadfloar(s1);
         If temp>0 then
         r:=ln(temp) else raise Ematherror.Create('Invalid Floating Operator. LN needs value >0');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='L') then if (s[i+1]='G') and (s[i+2]='(') then
         begin
         sc:=1;
         none:=false;
         noneno:=i+1;
         for j:=i+3 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         ns:=j;
         break;
         end;
         end;
         end;
         s1:=copy(s,i+3,ns-i-3);
         temp:=loadfloar(s1);
         If temp>0 then
         r:=ln(temp)/ln(10) else raise Ematherror.Create('Invalid Floating Operator. LG needs value >0');
         s1:='('+floattostr(r)+')';
         delete(s,i,ns-i+1);
         insert(s1,s,i);
         end;

If (s[i]='I') then if (s[i+1]='F') and (s[i+2]='(') then
         begin
         sc:=0;
         noneno:=i+1;
         nv1:=0;
         none:=false;
         for j:=i+2 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then sc:=sc-1;
         If sc=0 then
         begin
          endif:=j;
          break;
         end;
         end;
         sc:=0;
         For j:=i+3 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then sc:=sc-1;
         If (s[j]=';') and (sc=0) then
         begin
         nv1:=j;
         break;
         end;
         end;
         sc:=1;
         sv1:=copy(s,i+3,nv1-i-3);
         for j:=nv1+1 to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then sc:=sc-1;
         If (s[j]=';') and (sc=1) then
         begin
         ns:=j;
         break;
         end;
         end;
         s1:=copy(s,nv1+1,ns-nv1-1);
         
         for j:=ns to length(s) do
         begin
         If s[j]='(' then sc:=sc+1;
         If s[j]=')' then
         begin
         sc:=sc-1;
         If sc=0 then begin
         nv1:=j;
         break;
         end;
         end;
         end;
         sv2:=copy(s,ns+1,nv1-ns-1);
         y:=0;
         for z:=1 to length(sv1) do
         begin
         If (sv1[z]='>') and (sv1[z+1]<>'=') then
         begin
         znak:=[ZBolhe];
         y:=z;
         break;
         end;
         If (sv1[z]='<') and (sv1[z+1]<>'=') and (sv1[z+1]<>'>') then
         begin
         znak:=[ZMenhe];
         y:=z;
         break;
         end;
         If sv1[z]='=' then
         begin
         znak:=[ZRavno];
         y:=z;
         break;
         end;
         If (sv1[z]='>') and (sv1[z+1]='=') then
         begin
         znak:=[ZBolheRavno];
         y:=z;
         break;
         end;
         If (sv1[z]='<') and (sv1[z+1]='=') then
         begin
         znak:=[ZMenheRavno];
         y:=z;
         break;
         end;
         If (sv1[z]='<') and (sv1[z+1]='>') then
         begin
         znak:=[ZNeRavno];
         y:=z;
         break;
         end;
         end;
         If (znak=[Zbolhe]) or (znak=[ZMenhe]) or (znak=[ZRavno]) then
         begin
         ysl1:=copy(sv1,1,y-1);
         ysl2:=copy(sv1,y+1,length(sv1)-y);
         end else begin
         ysl1:=copy(sv1,1,y-1);
         ysl2:=copy(sv1,y+2,length(sv1)-y-1);
         end;
         znak:=znak;
         temp:=0;
         If znak=[ZRavno] then
         begin
         If stringtofunctionX(ysl1,0,0,0)=stringtofunctionX(ysl2,0,0,0) then temp:=stringtofunctionx(s1,0,0,0) else temp:=stringtofunctionx(sv2,0,0,0);
         end;
         If znak=[ZNeRavno] then
         begin
         If stringtofunctionX(ysl1,0,0,0)<>stringtofunctionX(ysl2,0,0,0) then temp:=stringtofunctionx(s1,0,0,0) else temp:=stringtofunctionx(sv2,0,0,0);
         end;
         If znak=[ZBolhe] then
         begin
         If stringtofunctionX(ysl1,0,0,0)>stringtofunctionX(ysl2,0,0,0) then temp:=stringtofunctionx(s1,0,0,0) else temp:=stringtofunctionx(sv2,0,0,0);
         end;
         If znak=[ZMenhe] then
         begin
         If stringtofunctionX(ysl1,0,0,0)<stringtofunctionX(ysl2,0,0,0) then temp:=stringtofunctionx(s1,0,0,0) else temp:=stringtofunctionx(sv2,0,0,0);
         end;
         If znak=[ZMenheRavno] then
         begin
         If stringtofunctionX(ysl1,0,0,0)<=stringtofunctionX(ysl2,0,0,0) then temp:=stringtofunctionx(s1,0,0,0) else temp:=stringtofunctionx(sv2,0,0,0);
         end;
         If znak=[ZBolheRavno] then
         begin
         If stringtofunctionX(ysl1,0,0,0)>=stringtofunctionX(ysl2,0,0,0) then temp:=stringtofunctionx(s1,0,0,0) else temp:=stringtofunctionx(sv2,0,0,0);
         end;
         r:=temp;
         s1:='('+floattostr(r)+')';
         delete(s,i,endif-i+1);
         insert(s1,s,i);
         break;
         end;
end;
Until none;
result:=s;
end;

Function StringtofunctionX(fstr : string; X,y, z :real) : real;
var s,s1,s2,s3,s4:string;
breakzikl : boolean;
plus,i,a,b,sc,j:integer;
lr:real;
f : Tfunc;
begin
result:=0;
s:=Upcaseall(fstr);
If s='' then exit;
If s[1]<>'-' then
s:='0+'+s else s:='0'+s;
s:=DeleteProbeli(s);
Repeat
i:=findnextx(s);
If (s[i]='X') and (s[i-1]<>'E') then
begin
delete(s,i,1);
s4:=floattostr(x);
s4:='('+s4+')';
insert(s4,s,i);
end;
Until findnextx(s)=-1;

Repeat
i:=findnexty(s);
If (s[i]='Y') then
begin
delete(s,i,1);
s4:=floattostr(y);
s4:='('+s4+')';
insert(s4,s,i);
end;
Until findnexty(s)=-1;

Repeat
i:=findnextz(s);
If (s[i]='Z') then
begin
delete(s,i,1);
s4:=floattostr(z);
s4:='('+s4+')';
insert(s4,s,i);
end;
Until findnextz(s)=-1;

Repeat
i:=findnextpi(s);
If (s[i]='P') and (s[i+1]='I') then
begin
delete(s,i,2);
s4:=floattostr(pi);
s4:='('+s4+')';
insert(s4,s,i);
end;
Until findnextpi(s)=-1;
 Repeat
  breakzikl:=true;
  for i:=1 to length(s) do
  If (s[i]='(') then
  If findprevioschar(s,i-1,1)<>'F' then
  if findprevioschar(s,i-1,2)<>'G' then
  begin
   sc:=0;
   for j:=i to length(s) do
   begin
    If s[j]='(' then sc:=sc+1;
    If s[j]=')' then
    begin
     sc:=sc-1;
     If sc=0 then
     If findexpression(copy(s,i+1,j-i-1))=true then
     begin
      s4:=copy(s,i+1,j-i-1);
      try
       s4:=floattostr(StringtofunctionX(s4,0,0,0));
       delete(s,i+1,j-i-1);
       insert(s4,s,i+1);
       breakzikl:=false;
       break;
       except
      end;
     end;
    end;
   end;
  end;
 Until breakzikl=true;

s:=replacefunctionstoresult(s);
 try
repeat
plus:=findnextf(s).Nofunction;
f:=findnextf(s).Typefunction;
s1:=copy(s,findnextl(plus,s)+1,plus-findnextl(plus,s)-1);
s2:=copy(s,plus+1,findnextr(plus,s)-plus-1);
a:=findnextl(plus,s);
b:=findnextr(plus,s);
system.delete(s,a+1,b-a-1);
lr:=0;
If f=[fnone] then break;
If f=[Fpower] then lr:=power(loadfloar(s1),loadfloar(s2));
If f=[fplus] then lr:=loadfloar(s1)+loadfloar(s2);
If f=[fminus] then lr:=loadfloar(s1)-loadfloar(s2);
If f=[fdivide] then
begin
If loadfloar(s2)<>0 then
lr:=loadfloar(s1)/loadfloar(s2) else raise EMathError.create('Error by devisiot on zerro');//lr:=MaxExtended;
end;
If f=[fmultiply] then lr:=loadfloar(s1)*loadfloar(s2);
If lr>=0 then s3:=floattostr(lr) else s3:='('+floattostr(lr)+')';
insert(s3,s,a+1);
until findnextf(s).Typefunction=[fnone];
  except
  raise EMathError.create('Error');
  end;

result:=loadfloar(s);
end;

Function findexpression(str : String):boolean;
var i,sc:integer;
pass:boolean;
begin
result:=false;
pass:=true;
sc:=0;
for i:=1 to length(str) do begin
If (str[i]='(') then sc:=sc+1;
If (str[i]=')') then sc:=sc-1;
If sc<0 then pass:=false;
end;
for i:=length(str) downto 1 do begin
If (str[i]=')') then sc:=sc+1;
If (str[i]='(') then sc:=sc-1;
If sc<0 then pass:=false;
end;
If pass then
for i:=1 to length(str) do begin
If (((str[i]='+') or (str[i]='-')) and (i<>1) and (str[i-1]<>'E')) or (str[i]='/') or (str[i]='*') or (str[i]='^') or (str[i]='S') or (str[i]='N') or ((str[i]='E') and (str[i+1]='X')) or (str[i]='I') or (str[i]='R') then
begin
result:=true;
break;
end;
end;
end;

/////////////////////////////////////////////////////////////////////
//                                                                 //
//                                                                 //
//        Find Erros In Exception                                  //
//                                                                 //
//                                                                 //
/////////////////////////////////////////////////////////////////////

Function FindErrors(Funct : String; Displacement: integer; var errorchar : integer) : String;
var smif,tsz,sc1,sc,i,j,k,l,h,ltestsum: integer;
fun : TFindFuncion;
ltest2,ltest, go_out, w1,w2: boolean;
st1,st2,st : string;
tests : array[1..6] of boolean;

//////////////////////////////////////

function extinmask(mask : string; ext : string):boolean;
var i,j:integer;
begin
result:=false;
If mask='||' then
begin
result:=true;
exit;
end;
for i:=1 to length(mask) do
if mask[i]='|' then
for j:=i to length(mask) do
begin
If mask[j]='|' then
if upcaseall(copy(mask,i+1,j-i-1))=upcaseall(ext) then
begin
result:=true;
end;
end;
end;

///////////////////////////////////////////////////////

begin
 Result:='';
 errorchar:=-1;
 funct:=' '+funct+' ';
 sc:=0;
 for i:=1 to length(Funct) do
 If not (Upcase(Funct[i]) in ['A'..'Z']) and not (Upcase(Funct[i]) in ['0'..'9']) and not (funct[i] in znaki) and not (funct[i] in logicznaki ) and (funct[i]<>'^') and (funct[i]<>DecimalSeparator) and (funct[i]<>'(') and (funct[i]<>')') and (funct[i]<>';') and (funct[i]<>' ') then begin result:='UnUsed Char : "'+Funct[i]+'", char number '+inttostr(i-1+Displacement);  errorchar:=i-1+Displacement; end;
 If result<>'' then exit;
 for i:=1 to length(Funct) do
 begin
  If (Funct[i]='(') then sc:=sc+1;
  If (Funct[i]=')') then sc:=sc-1;
  If sc<0 then result:='Brackets are not compensated';
 end;
 If result<>'' then exit;
 sc:=0;
 for i:=length(Funct) downto 1 do
 begin
  If (Funct[i]=')') then sc:=sc+1;
  If (Funct[i]='(') then sc:=sc-1;
  If sc<0 then result:='Brackets are not compensated';
 end;
 If result<>'' then exit;

 fun.name:='';
 fun.FirstChar:=1;
 Repeat
  fun:=FindFunctionname(Funct,fun.FirstChar+1);
  i:=fun.firstcharname;
  If Fun.name='' then break;
  If not ExtInMask('|RAD(|SIN(|COS(|TAN(|COTAN(|ARCSIN(|ARCCOS(|ARCTAN(|ARCCOTAN(|SQRT(|ABS(|LN(|LG(|LOGN(|EXP(|ROUND(|IF(|X|PI|Y|Z|E|',Fun.name) then
  begin
   delete(fun.name,length(fun.name),1);
   If not ExtInMask('|RADX|SINX|COSX|TANX|COTANX|ARCSINX|ARCCOSX|ARCTANX|ARCCOTANX|SQRTX|ABSX|LNX|LGX|EXPX|ROUNDX|RAD|SIN|COS|TAN|COTAN|ARCSIN|ARCCOS|ARCTAN|ARCCOTAN|SQRT|ABS|LN|LG|LOGN|EXP|ROUND|IF|X|Y|Z|PI|E|',Fun.name) then
   begin Result:='Uncnown Function : "'+Fun.Name+'", symbol number '+inttostr(i-1+Displacement); errorchar:=i-1+Displacement; end else begin If not ExtInMask('|RADX|SINX|COSX|TANX|COTANX|ARCSINX|ARCCOSX|ARCTANX|ARCCOTANX|SQRTX|ABSX|LNX|LGX|EXPX|ROUNDX|X|Z|Y|PI|E|',Fun.name) then begin result:='No "(" after '+UpcaseAll(fun.name)+', symbol number '+inttostr(fun.width+i-2+Displacement); errorchar:=fun.width+i-2+Displacement; end; end;
  end;
 Until fun.FirstChar<0;
 If result<>'' then exit;
 for i:=1 to length(Funct)-1 do
 If (Funct[i]='(') and (findnextcharwithoutznaki(funct,i+1)=')') then begin Result:='No Value In Brackets,  char number ' +inttostr(i-1+Displacement); errorchar:=i-1+Displacement; end;
 If result<>'' then exit;
 {}
 for i:=1 to length(Funct)-2 do
 If IsIfOrLognEnd(Funct,i,true)<>-1 then
 begin
  sc:=1;
  smif:=IsIfOrLognEnd(Funct,i,true)+1;
  for j:=i+smif to length(funct)-1 do
  begin
   If funct[j]='(' then sc:=sc+1;
   If funct[j]=')' then sc:=sc-1;
   If sc=0 then begin st:=copy(funct,i+smif,j-i-smif); break; end;
  end;
  tsz:=0;
  sc:=0;
  for j:=1 to length(st) do
  begin
   If st[j]='(' then sc:=sc+1;
   If st[j]=')' then sc:=sc-1;
  If (st[j]=';') and (sc=0) then inc(tsz);
  end;
  If tsz>2 then begin Result:='Unnecessary value in "IF", char number '+inttostr(i-2+smif+Displacement); errorchar:=i-2+smif+Displacement; exit; end;
  If tsz<2 then begin Result:='Nesessary three values In "IF", char number '+inttostr(i-2+smif+Displacement); errorchar:=i-2+smif+Displacement; exit; end;
  sc:=0;
  for j:=i+smif to length(funct)-1 do
  begin
   If funct[j]='(' then sc:=sc+1;
   If funct[j]=')' then sc:=sc-1;
   If (funct[j]=';') and (sc=0) then
   begin
    st:=copy(funct,i+smif,j-i-smif);
    If st='' then
    begin
     Result:='No Value Logical Test In "IF", char number '+inttostr(i-4+smif+Displacement);
     errorchar:=i-4+smif+Displacement;
     exit;
    end;
    for k:=1 to 6 do tests[k]:=false;
    ltestsum:=-1;
    go_Out:=false;
    for h:=1 to length(st) do
    If st[h]=';' then begin go_Out:=True; break; end;
    If go_Out then break;
    for k:=1 to length(st) do
    begin
     If st[k]='>' then begin If tests[1]=false then tests[1]:=true else begin result:='Dublicate logical char (">"), char number '+ inttostr(i-2+smIf+k+Displacement); errorchar:=i-2+smIf+k+Displacement; exit; end; end;
     If st[k]='<' then begin If tests[2]=false then tests[2]:=true else begin result:='Dublicate logical char ("<"), char number '+ inttostr(i-2+smIf+k+Displacement); errorchar:=i-2+smIf+k+Displacement; exit; end; end;
     If st[k]='=' then begin If tests[3]=false then tests[3]:=true else begin result:='Dublicate logical char ("="), char number '+ inttostr(i-2+smIf+k+Displacement); errorchar:=i-2+smIf+k+Displacement; exit; end; end;
     If (st[k]='<') and (findnextchar(st,k+1)='>') then tests[4]:=True;
     If (st[k]='<') and (findnextchar(st,k+1)='=') then tests[5]:=True;
     If (st[k]='>') and (findnextchar(st,k+1)='=') then tests[6]:=True;
     If (st[k]='>') and (findnextchar(st,k+1)='<') then begin result:='Invalid logical test ("><"). May be it "<>"?. Char number '+ inttostr(i-2+smIf+k+Displacement); errorchar:=i-2+smIf+k+Displacement; exit; end;
     If (st[k]='=') and (findnextchar(st,k+1)='>') then begin result:='Invalid logical test ("=>"). May be it ">="?. Char number '+ inttostr(i-2+smIf+k+Displacement); errorchar:=i-2+smIf+k+Displacement; exit; end;
     If (st[k]='=') and (findnextchar(st,k+1)='<') then begin result:='Invalid logical test ("=<"). May be it "<="?. Char number '+ inttostr(i-2+smIf+k+Displacement); errorchar:=i-2+smIf+k+Displacement; exit; end;
     If (st[k]='>') or (st[k]='<') or (st[k]='=') then inc(ltestsum);
    end;
    If ltestsum=-1 then begin result:='No logical test in "IF". Char number '+ inttostr(i+smif-1+Displacement); errorchar:=i+smif-1+Displacement; exit; end;
    If (ltestsum>0) and (tests[4]<>true) and (tests[5]<>true) and (tests[6]<>true) then begin result:='Invalid logical test. Please, recheck value. Char number '+ inttostr(i+2+Displacement); errorchar:=i+2+Displacement; exit; end;
    sc:=0;
    For k:=j+1 to length(funct) do
    begin
     If funct[k]='(' then sc:=sc+1;
     If funct[k]=')' then sc:=sc-1;
     If (funct[k]=';') and (sc=0) or (k=length(funct)) then
     begin
      st:=copy(funct,j+1,k-j-1);
      st1:=st;
      If finderrors(st,j-1+Displacement,tsz)<>'' then begin result:=finderrors(st,j-1+Displacement,tsz); errorchar:=tsz; exit; end;
      IF not ValueExists(st) then begin Result:='No Value_On_True in "IF", char number '+inttostr(j-1+Displacement); errorchar:=j-1+Displacement; exit; end;
      sc:=0;
      for l:=k+1 to length(funct) do
      begin
       If funct[l]='(' then sc:=sc+1;
       If funct[l]=')' then sc:=sc-1;
       If (sc=-1) {or (l=length(funct))} then
       begin
        st:=copy(funct,k+1,l-k-1);
        st2:=st;
        If finderrors(st,k-1+Displacement,tsz)<>'' then begin result:=finderrors(st,k-1+Displacement,tsz); errorchar:=tsz; exit; end;
        IF not ValueExists(st) then begin Result:='No Value_On_False in "IF", char number '+inttostr(k-1+Displacement); errorchar:=k-1+Displacement; exit; end;
        break;
       end;
      end;
      break;
     end;
    end;
   end;
  end;
 end;
 st1:='';
 If result<>'' then exit;
 for i:=1 to length(funct) do
 If IsIfOrLognEnd(Funct,i,false)<>-1 then
 begin
  smif:=IsIfOrLognEnd(Funct,i,false)+1;
  sc:=1;
  for j:=i+smif to length(funct)-1 do
  begin
   If funct[j]='(' then sc:=sc+1;
   If funct[j]=')' then sc:=sc-1;
   If sc=0 then begin st:=copy(funct,i+smif,j-i-smif); break; end;
  end;
  tsz:=0;
  sc:=0;
  for j:=1 to length(st) do
  begin
   If st[j]='(' then sc:=sc+1;
   If st[j]=')' then sc:=sc-1;
  If (st[j]=';') and (sc=0) then inc(tsz);
  end;
  If tsz>1 then begin Result:='Unnecessary value in "LOGN", char number '+inttostr(i-6+smif+Displacement); errorchar:=i-6+smif+Displacement; exit; end;
  If tsz<1 then begin Result:='Nesessary two values In "LOGN", char number '+inttostr(i-6+smif+Displacement); errorchar:=i-6+smif+Displacement; exit; end;
  sc:=0;

  for j:=i+smif to length(funct) do
  begin
   If funct[j]='(' then sc:=sc+1;
   If funct[j]=')' then sc:=sc-1;
   If (funct[j]=';') and (sc=0) or (j=length(funct)) then
   begin
    If j=length(funct) then begin result:='Necessary two values In "LOGN. Char number '+ inttostr(i+1+smif+Displacement); errorchar:=i+1+smif+Displacement; exit; end;
    st:=copy(funct,i+smif,j-i-smif);
    If not ValueExists(st) then begin result:='No exception in "LOGN". Char number '+ inttostr(j-2+Displacement); errorchar:=j-2+Displacement; exit; end;
    st1:=st;
    for k:=j to length(funct) do
    begin
     If funct[k]='(' then sc:=sc+1;
     If funct[k]=')' then sc:=sc-1;
     If (sc=-1) or (k=length(funct)-1) then
     begin
      st:=copy(funct,j+1,k-j-1);
      If not ValueExists(st) then
      begin
       result:='No exception "BASE" in "LOGN". Char number '+ inttostr(j-6+smif+Displacement);
       errorchar:=j-1+Displacement;
       exit;
      end;
      break;
     end;
    end;
    break;
   end;
  end;
 end;

 sc:=0;
 sc1:=0;
 w1:=false;
 w2:=false;
 ltest:=false;
 ltest2:=false;
 for i:=1 to length(funct) do
 begin
  If IsIfOrLognEnd(funct,i,true)<>-1 then
  begin
   sc:=0;
   w1:=false;
   ltest:=true;
  end;
  If IsIfOrLognEnd(funct,i,false)<>-1 then
   begin
   sc1:=0;
   w2:=false;
   ltest2:=true;
  end;
  If ltest then
  begin
   If funct[i]='(' then begin sc:=sc+1; w1:=true; end;
   If funct[i]=')' then sc:=sc-1;
   If (sc=0) and w1 then ltest:=false;
  end;
  If ltest2 then
  begin
   If funct[i]='(' then begin sc1:=sc1+1; w2:=true end;
   If funct[i]=')' then sc1:=sc1-1;
   If (sc1=0) and w2 then ltest2:=false;
  end;
  If not ltest and ((funct[i]='>') or (funct[i]='<') or (funct[i]='=')) then begin result:='Unnecessary logical test. Char number '+inttostr(i-1+Displacement); errorchar:=i-1+Displacement; exit; end;
  If not ltest and not ltest2 and (funct[i]=';') then begin result:='Unnecessary ";" Char number '+inttostr(i-1+Displacement); errorchar:=i-1+Displacement; exit; end;
 end;
 for i:=1 to length(funct) do
 If (funct[i]=')')  and (findnextchar(funct,i+1)<>')') and not (findnextchar(funct,i+1) in znaki) and not (findnextchar(funct,i+1) in logicznaki) and (findnextchar(funct,i+1)<>'') and (findnextchar(funct,i+1)<>';') then begin result:='No needs action, char number '+inttostr(i+Displacement); errorchar:=i+Displacement; exit; end;
  for i:=1 to length(funct) do
  begin
   If (Upcase(funct[i])='I') and (Upcase(Findnextchar(funct,i+1))<>'F') and (Upcase(Findnextchar(funct,i+1))<>'N') and not (findnextchar(funct,i+1) in znaki) and (findnextchar(funct,i+1)<>')') and (findnextchar(funct,i+1)<>';') and (findnextchar(funct,i+1)<>'') and not (findnextchar(funct,i+1) in logicznaki) then begin result:='No needs action, char number '+inttostr(i+Displacement); errorchar:=i+Displacement; exit; end;
   If (Upcase(funct[i])='X') and (Upcase(Findnextchar(funct,i+1))<>'P') and not (findnextchar(funct,i+1) in znaki) and (findnextchar(funct,i+1)<>')') and (findnextchar(funct,i+1)<>';') and (findnextchar(funct,i+1)<>'') and not (findnextchar(funct,i+1) in logicznaki) then begin result:='No needs action, char number '+inttostr(i+Displacement); errorchar:=i+Displacement; exit; end;
  end;
 for i:=1 to length(funct) do
 If (funct[i] in zifri) and ((findnextchar(funct,i+1) in bukviF) or (findnextchar(funct,i+1)='(')) then begin result:='No needs action, char number '+inttostr(i+Displacement); errorchar:=i+Displacement; exit; end;
 for i:=2 to length(funct) do
 If ((funct[i]=DecimalSeparator)) or ((funct[i] in zifri) and (not (findprevioschar(funct,i-1,1) in zifri) or (findprevioschar(funct,i-1,1)='')))  then If testvalueondb(funct,i)=false then  begin result:='Invalid value, char number '+inttostr(i-1+Displacement); errorchar:=i-1+Displacement; break; end;
end;

Function FindFunctionname(s:string;i : integer) : TFindFuncion;
var j,w:integer;
ss:string;
begin
 Result.FirstChar:=-1;
 for j:=i to length(s) do
 begin
  If (s[j] in BukviF) and not ((Upcase(s[j])='X') and not (findnextchar(s,j+1) in BukviF)) then
  begin
  ss:=(findnextchar(s,j+1));
  result.firstcharname:=j;
  for w:=j to length(s) do
  If (not (s[w] in BukviF) and (s[w]<>#32)  and (UpcaseAll(copy(s,j,w-j))<>'E') and (UpcaseAll(copy(s,j,w-j))<>'X')) or ((findnextchar(s,w+1)='')) then
  begin
  If (UpcaseAll(copy(s,j,w-j))<>'X') then
  begin
  result.width:=length(copy(s,j,w-j+1));
  result.name:=DeleteProbeli(copy(s,j,w-j+1));
  If not (result.name[length(result.name)] in bukviF) and (result.name[length(result.name)]<>'(') then delete(result.name,length(result.name),1);
  If result.name[length(result.name)]<>'(' then result.name:=result.name+' ';
  If w=i then exit else result.FirstChar:=w;
  exit;
  end;
  end;
  end;
 end;
end;

Function FindNextChar(s : string; i : integer): char;
var j:integer;
begin
 result:=#0;
 For j:=i to length(s) do
 If s[j]<>' ' then begin
 result:=s[j];
 break;
 end;
end;

Function findnextcharwithoutznaki(s : string; i : integer):char;
var j:integer;
begin
 result:=#0;
 For j:=i to length(s) do
 If (s[j]<>' ') and not (s[j] in znaki) then begin
 result:=s[j];
 break;
 end;
end;

Function FindpreviosChar(s : string; i : integer; no : integer): char;
var j:integer;
begin
 result:=#0;
 For j:=i downto 1 do
 If s[j]<>' ' then begin
 dec(no);
 If no<=0 then
 begin
 result:=s[j];
 break;
 end;
 end;
end;

Function FindNextCharNo(s : string; i : integer; var no : integer): char;
var j:integer;
begin
 result:=#0;
 For j:=i to length(s) do
 If s[j]<>' ' then begin
 result:=s[j];
 no:=j;
 break;
 end;
end;

Function ValueExists(S : String) : Boolean;
var i:integer;
begin
 result:=false;
 If s='' then exit;
 For i:=1 to length(s) do
 If s[i]<>' ' then
 begin
 result:=true;
 break;
 end;
end;

Function DeleteProbeli(S : String) : String;
 var i:integer;
begin
 for i:=length(s) downto 1 do
 If s[i]=' ' then delete(s,i,1);
 Result:=s;
end;

Function IsIfOrLognEnd(s : String; beginchar : Integer; ifLog : boolean) : integer;
var no:integer;
begin
result:=-1;
 If iflog then
 begin
  If Upcase(s[beginchar])='I' then
  If Upcase(findnextcharno(s,beginchar+1,no))='F' then
  If findnextcharno(s,no+1,no)='(' then result:=no-beginchar;
 end else begin
    If Upcase(s[beginchar])='L' then
    If Upcase(findnextcharno(s,beginchar+1,no))='O' then
    If Upcase(findnextcharno(s,no+1,no))='G' then
    If Upcase(findnextcharno(s,no+1,no))='N' then
    If findnextcharno(s,no+1,no)='(' then result:=no-beginchar;
 end;
end;

Function testvalueondb(s : string; i : integer):boolean;
var j,no_,db : integer;
begin
 db:=0;
 no_:=2;
 result:=true;
 For j:=i to length(s) do
 If (s[j]<>' ') and not (s[j] in ['0'..'9']) then begin
 dec(no_);
 If s[j]=DecimalSeparator then inc(db);
 If no_=0 then
 begin
 If db>1 then result:=false;
 break;
 end;
 end;
end;

{procedure testoneformat(s : string; n : integer) : boolean;
var i:integer;
begin
 For i:=n to length(s) do

end;        }

end.
